using Telerik.TestingFramework.Controls.KendoUI;
using Telerik.WebAii.Controls.Html;
using Telerik.WebAii.Controls.Xaml;
using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

using System.Web;

using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts;
using ArtOfTest.WebAii.Design;
using ArtOfTest.WebAii.Design.Execution;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.Silverlight;
using ArtOfTest.WebAii.Silverlight.UI;

using ArtOfTest.WebAii.Messaging.Http; //Needed for Telerik HTTPProxy

namespace EpicMix
{
    public class HTTPProxy : BaseWebAiiTest
    {
        #region [ Dynamic Pages Reference ]

        private Pages _pages;

        /// <summary>
        /// Gets the Pages object that has references
        /// to all the elements, frames or regions
        /// in this project.
        /// </summary>
        public Pages Pages
        {
            get
            {
                if (_pages == null)
                {
                    _pages = new Pages(Manager.Current);
                }
                return _pages;
            }
        }

        #endregion
        
        // START TEST VARIABLES
        
            // Omniture URL (partial)
            private string omnitureUrl = @".snow.com/b/ss/";
            
            // Found flag for the omnitureUrl
            private static Boolean found = false;
            
            // Dictionary to hold the query string parameters and values
            private static Dictionary<string, string> dictionary = null;
        
        // END TEST VARIABLES
        
        public Dictionary<string, string> NavigateToUnauthenticatedUrl(string testUrl)
        {
            found = false;
            
            // Add our HTTP response event handler. For each response the proxy gets, parse for the Omniture URL's query string parameters
            ResponseListenerInfo li = new ResponseListenerInfo(GetQueryStringParamatersAndValues);
            Manager.Current.Http.AddBeforeResponseListener(li);
            
            // Navigate to the given URL (passed in from the test case)
            Manager.Current.ActiveBrowser.NavigateTo(testUrl);
            
            // Wait '5000' msec for url:'{testUrl}'
            Manager.Current.ActiveBrowser.WaitForUrl(testUrl, true, 5000);
            
            // Wait for the page to completely load
            Manager.Current.ActiveBrowser.Frames.WaitAllUntilReady();
            
            // We don't need the event handler any longer. Removing it stops listening to responses in the proxy
            Manager.Current.Http.RemoveBeforeResponseListener(li);
            
            return dictionary;
        }
        
        public Dictionary<string, string> ClickLogInButtonAndListen(string testUrl)
        {
            found = false;
            
            // Add our HTTP response event handler. For each response the proxy gets, parse for the Omniture URL's query string parameters
            ResponseListenerInfo li = new ResponseListenerInfo(GetQueryStringParamatersAndValues);
            Manager.Current.Http.AddBeforeResponseListener(li);
            
            // Click 'DoLoginLink'
            Pages.Welcome.DoLoginLink.Click(false);
            
            // Wait '5000' msec for url:'{testUrl}'
            Manager.Current.ActiveBrowser.WaitForUrl(testUrl, true, 5000);
            
            // Wait for the page to completely load
            Manager.Current.ActiveBrowser.Frames.WaitAllUntilReady();
            Manager.Current.ActiveBrowser.WaitUntilReady();
            Manager.Current.ActiveBrowser.WaitForAjax(15000);
            
            // Wait for '1000' msec. (this is to conpensate for the Omniture pixel being one of the last things called
            System.Threading.Thread.Sleep(1000);
            
            // We don't need the event handler any longer. Removing it stops listening to responses in the proxy
            Manager.Current.Http.RemoveBeforeResponseListener(li);
            
            return dictionary;
        }
        
        public Dictionary<string, string> ClickAddToCartButtonAndListen()
        {
            found = false;
            
            Console.WriteLine("Omniture Url: " + omnitureUrl); //DEBUGGING
            
            // Add our HTTP response event handler. For each response the proxy gets, parse for the Omniture URL's query string parameters
            ResponseListenerInfo li = new ResponseListenerInfo(GetQueryStringParamatersAndValues);
            Manager.Current.Http.AddBeforeResponseListener(li);
            
            // Click 'Button'
            Pages.OfficialVailVailLift.Button.Click(false);
            
            // Click 'AddToCartButton'
            //Pages.OfficialVailVailLift.AddToCartButton.Click(false); // use this once reliable
            
            // Wait for the page to completely load
            Manager.Current.ActiveBrowser.Frames.WaitAllUntilReady();
            Manager.Current.ActiveBrowser.WaitUntilReady();
            Manager.Current.ActiveBrowser.WaitForAjax(15000);
            
            // Wait for '1000' msec. (this is to conpensate for the Omniture pixel being one of the last things called
            System.Threading.Thread.Sleep(1000);
            
            // We don't need the event handler any longer. Removing it stops listening to responses in the proxy
            Manager.Current.Http.RemoveBeforeResponseListener(li);
            
            return dictionary;
        }
        
        private void GetQueryStringParamatersAndValues(object sender, HttpResponseEventArgs e)
        {
            
            Console.WriteLine("URL" + e.Response.Request.RequestUri); // DEBUGGING
            
            if (found == false)
            {
                // Get the current RequestUri
                String currentRequestUri = e.Response.Request.RequestUri;
                
                // If the current request uri begins with the omnitureUrl
                if (currentRequestUri.Contains(omnitureUrl))
                {
                    // Set found flag to true
                    found = true;
                    
                    // Trim the RequestUri by removing anything before the query string
                    String queryString = currentRequestUri.Substring(currentRequestUri.IndexOf("?"));
                    
                    // Decode the Url encoded string
                    String decodedQueryString = Uri.UnescapeDataString(queryString);
                    
                    // Remove the leading ? (which should be the first character)
                    decodedQueryString = decodedQueryString.Substring(1);
                    
                    // Add parameter:value pairs to the dictionary
                    dictionary = decodedQueryString.Replace("?", "").Split('&').ToDictionary(x => x.Split('=')[0], x => x.Split('=')[1]);
                    
                    // DEBUGGING: Write each query string paramater to the log
                    //foreach (var pair in dictionary) { Manager.Current.Log.WriteLine(Environment.NewLine + "[Key] " + pair.Key + Environment.NewLine + "[Value] " + pair.Value); }
                }
            }
        }
    }
}